module.exports = function() {

  const path = require('path');

  class Config {
    constructor(dir, args) {
      this.dir = dir;
      this.args = args;
    }

    _require(name) {
      return require(name);
    }

    _load() {
      return Promise.resolve(this._require(path.join(this.dir, '.rsyncy.js')));
    }

    parse() {
      return this._load().then(opts => {
        opts.source = opts.source || this.dir;
        return opts;
      });
    }

    static parse(dir, args) {
      let config = new this(dir, args);
      return config.parse();
    }

  }

  return Config;
}();
